xmltooling::X509Credential Class Referenceabstract

Wraps an X.509-based Credential. More...

`#include <xmltooling/security/X509Credential.h>`

Inheritance diagram for xmltooling::X509Credential:
[legend]
Collaboration diagram for xmltooling::X509Credential:
[legend]

## Public Types

enum | ResolveTypes { RESOLVE_CERTS = 4 , RESOLVE_CRLS = 8 }
| Bitmask constants for limiting resolution process inside a CredentialResolver.
enum | KeyInfoTypes { KEYINFO_X509_CERTIFICATE = 4 , KEYINFO_X509_SUBJECTNAME = 8 , KEYINFO_X509_ISSUERSERIAL = 16 , KEYINFO_X509_DIGEST = 32 }
| Bitmask of supported KeyInfo content to generate.
Public Types inherited from xmltooling::Credential
enum | ResolveTypes { RESOLVE_KEYS = 1 , RESOLVE_NAMES = 2 }
| Bitmask constants for limiting resolution process inside a CredentialResolver.
enum | UsageTypes { UNSPECIFIED_CREDENTIAL = 0 , SIGNING_CREDENTIAL = 1 , TLS_CREDENTIAL = 2 , ENCRYPTION_CREDENTIAL = 4 }
| Bitmask of use cases for credentials.
enum | KeyInfoTypes { KEYINFO_KEY_VALUE = 1 , KEYINFO_KEY_NAME = 2 }
| Bitmask of supported KeyInfo content to generate.

## Public Member Functions

virtual const std::vector< XSECCryptoX509 * > & | getEntityCertificateChain () const =0
| Gets an immutable collection of certificates in the entity's trust chain.
virtual const std::vector< XSECCryptoX509CRL * > & | getCRLs () const =0
| Gets an immutable collection of all CRLs associated with the credential.
virtual const char * | getSubjectName () const =0
| Gets the subject name of the first certificate in the chain.
virtual const char * | getIssuerName () const =0
| Gets the issuer name of the first certificate in the chain.
virtual const char * | getSerialNumber () const =0
| Gets the serial number of the first certificate in the chain.
virtual void | extract ()=0
| Extracts properties like issuer and subject from the first certificate in the chain.
Public Member Functions inherited from xmltooling::Credential
virtual unsigned int | getUsage () const =0
| Get credential usage types.
virtual const char * | getAlgorithm () const =0
| Returns an algorithm identifier for the Credential.
virtual unsigned int | getKeySize () const =0
| Returns the size of the key in bits.
virtual const XSECCryptoKey * | getPrivateKey () const =0
| Returns a secret or private key to use for signing or decryption operations.
virtual const XSECCryptoKey * | getPublicKey () const =0
| Returns a secret or public key to use for verification or encryption operations.
virtual const std::set< std::string > & | getKeyNames () const =0
| Returns names representing the Credential.
virtual xmlsignature::KeyInfo * | getKeyInfo (bool compact=false) const =0
| Returns a ds:KeyInfo object representing the Credential for use in communicating with other entities.
virtual const CredentialContext * | getCredentialContext () const
| Get the credential context information, which provides additional information specific to the context in which the credential was resolved.

## Detailed Description

Wraps an X.509-based Credential.

## Member Function Documentation

## extract()

virtual void xmltooling::X509Credential::extract | ( |  | ) |

pure virtual

Extracts properties like issuer and subject from the first certificate in the chain.

Implemented in xmltooling::BasicX509Credential.

## getCRLs()

virtual const std::vector< XSECCryptoX509CRL * > & xmltooling::X509Credential::getCRLs | ( |  | ) | const

pure virtual

Gets an immutable collection of all CRLs associated with the credential.

Returns
  CRLs associated with the credential

Implemented in xmltooling::BasicX509Credential.

## getEntityCertificateChain()

virtual const std::vector< XSECCryptoX509 * > & xmltooling::X509Credential::getEntityCertificateChain | ( |  | ) | const

pure virtual

Gets an immutable collection of certificates in the entity's trust chain.

The entity certificate is contained within this list. No specific ordering of the certificates is guaranteed.

Returns
  a certificate chain

Implemented in xmltooling::BasicX509Credential.

## getIssuerName()

virtual const char * xmltooling::X509Credential::getIssuerName | ( |  | ) | const

pure virtual

Gets the issuer name of the first certificate in the chain.

Returns
  the Issuer DN

Implemented in xmltooling::BasicX509Credential.

## getSerialNumber()

virtual const char * xmltooling::X509Credential::getSerialNumber | ( |  | ) | const

pure virtual

Gets the serial number of the first certificate in the chain.

Returns
  the serial number

Implemented in xmltooling::BasicX509Credential.

## getSubjectName()

virtual const char * xmltooling::X509Credential::getSubjectName | ( |  | ) | const

pure virtual

Gets the subject name of the first certificate in the chain.

Returns
  the Subject DN

Implemented in xmltooling::BasicX509Credential.

The documentation for this class was generated from the following file:

- xmltooling/security/X509Credential.h